<script setup lang="ts">
import { ref, nextTick, onMounted } from 'vue'
import type { VForm } from 'vuetify/components'

//store
import { useMaterialStore } from '@/stores/material'

const materialStore = useMaterialStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const loading = ref(false)

const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'ชื่อ',
    key: 'name',
    value: 'name'
  },
  {
    title: 'ขั้นต่ำ',
    key: 'minimum',
    value: 'minimum'
  },
  {
    title: 'จำนวนที่มี',
    key: 'amount',
    value: 'amount'
  },
  {
    title: 'หน่วย',
    key: 'type',
    value: 'type'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

function onSubmit() {
  // Implement your form submission logic here
}
function closeDialog() {
  materialStore.dialog = false
  nextTick(() => {
    materialStore.editMaterial = Object.assign({}, materialStore.initMaterial)
  })
}
onMounted(() => {
  materialStore.getMaterials()
})

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return

  const existMat = materialStore.materials.find(
    (material) =>
      material.name.trim().toLowerCase() === materialStore.editMaterial.name.trim().toLowerCase()
  )

  if (existMat) {
    console.log('update')
    existMat.amount = materialStore.editMaterial.amount
    existMat.minimum = materialStore.editMaterial.minimum
    existMat.name = materialStore.editMaterial.name
    existMat.type = materialStore.editMaterial.type
  } else {
    console.log('new save')
    materialStore.materials.push(materialStore.editMaterial)
  }
  for (const mat of materialStore.materials) {
    materialStore.saveMaterial(mat)
  }

  closeDialog()
}
</script>

<template>
  <div style="width: 100%; max-width: 1920px; margin: auto">
    <v-data-table
      :headers="headers"
      :items="materialStore.materials"
      height="300"
      fixed-header
      hide-default-footer
      disable-pagination
      overflow-y="hidden"
    >
      <template v-slot:top>
        <v-toolbar flat color="#AB9283">
          <v-toolbar-title>Material</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>

          <v-dialog v-model="materialStore.dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn size="40px" v-bind="props" prepend-icon="mdi-plus-thick" class="mr-5"> </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">New Material</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="materialStore.editMaterial.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="ชื่อวัตถุดิบ"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="materialStore.editMaterial.minimum"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="จำนวนขั้นต่ำ"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="materialStore.editMaterial.amount"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="จำนวนที่มีอยู่"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col cols="12">
                        <v-text-field
                          v-model="materialStore.editMaterial.type"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="หน่วยเรียก"
                          single-line
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn variant="text" @click="closeDialog()" class="mr-5"> Close </v-btn>
                <v-btn variant="text" @click="save()" class="mr-5"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- Delete Dialog -->
          <v-dialog v-model="materialStore.dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="materialStore.closeDelete"
                  >Cancel</v-btn
                >
                <v-btn color="blue-darken-1" variant="text" @click="materialStore.deleteItemConfirm"
                  >OK</v-btn
                >
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="materialStore.editItem(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" @click="materialStore.deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn @click="materialStore.initialize" class="mr-5"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>

<style scoped>
.v-sheet {
  background-color: #fff5e8;
}

.v-toolbar {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
  background-color: #ab9283;
}

.v-toolbar-title {
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-table {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: black;
}

.custom-header {
  background-color: #ffcb5e;
}
</style>
